/*
 * Copyright (c) 2011-2012 Gony
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE ABOVE LISTED COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

package jp.gonypage.dancingmissiles;

import javax.microedition.khronos.opengles.GL11;

public class ActorList {
	public ActorList(int aCapacity) {
		actors = new Actor[aCapacity];
		capacity = aCapacity;
		for (int i = 0;i < capacity;i++) {
			actors[i] = null;
		}
	}

	public boolean add(Actor actor) {
		for (int i = 0;i < capacity;i++) {
			if (actors[i] == null) {
				actors[i] = actor;

				return true;
			}
		}

		return false;
	}

	public boolean remove(Actor actor) {
		for (int i = 0;i < capacity;i++) {
			if (actors[i] == actor) {
				actors[i] = null;

				return true;
			}
		}

		return false;
	}

	public int getNum() {
		int num = 0;
		for (int i = 0;i < capacity;i++) {
			if (actors[i] != null) {
				num++;
			}
		}

		return num;
	}

	public void process() {
		for (Actor actor: actors) {
			if (actor != null) {
				actor.process();
			}
		}
	}

	public void draw(GL11 gl) {
		for (Actor actor: actors) {
			if (actor != null) {
				actor.draw(gl);
			}
		}
	}
	
	protected Actor[] actors;
	private int capacity;
}
