/*
 * Copyright (c) 2011-2012 Gony
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE ABOVE LISTED COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

package jp.gonypage.dancingmissiles;

import javax.microedition.khronos.opengles.GL11;

class Background extends Actor {
	public Background(DancingMissilesScene aScene) {
		super();

		scene = aScene;
	}

	@Override
	public void process() {
	}

	@Override
	public void draw(GL11 gl) {
		gl.glEnable(GL11.GL_TEXTURE_2D);
		gl.glEnableClientState(GL11.GL_VERTEX_ARRAY);
		gl.glEnableClientState(GL11.GL_TEXTURE_COORD_ARRAY);
		gl.glVertexPointer(3, GL11.GL_FLOAT, 0, vertices.getBuffer());
		gl.glTexCoordPointer(2, GL11.GL_FLOAT, 0, texCoords.getBuffer());
		for (int i = 0;i < 4;i++)
		{
			float x = (i & 1) * 20000.0f - 10000.0f;
			float z = (i / 2) * 20000.0f - 10000.0f;
			scene.getSkyTexture().bind(gl);
			gl.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
			gl.glPushMatrix();
			gl.glTranslatef(x, 2000.0f + scene.getCamera().getPosition().getY(), z);
			gl.glDrawArrays(GL11.GL_TRIANGLE_STRIP, 0, 4);
			gl.glDrawArrays(GL11.GL_TRIANGLE_STRIP, 4, 4);
			gl.glDrawArrays(GL11.GL_TRIANGLE_STRIP, 8, 4);
			gl.glDrawArrays(GL11.GL_TRIANGLE_STRIP, 12, 4);
			gl.glPopMatrix();
			scene.getGroundTexture().bind(gl);
			gl.glPushMatrix();
			gl.glTranslatef(x, -2000.0f + scene.getCamera().getPosition().getY(), z);
			gl.glDrawArrays(GL11.GL_TRIANGLE_STRIP, 0, 4);
			gl.glDrawArrays(GL11.GL_TRIANGLE_STRIP, 4, 4);
			gl.glDrawArrays(GL11.GL_TRIANGLE_STRIP, 8, 4);
			gl.glDrawArrays(GL11.GL_TRIANGLE_STRIP, 12, 4);
			gl.glPopMatrix();
		}
		gl.glDisableClientState(GL11.GL_TEXTURE_COORD_ARRAY);
		gl.glDisableClientState(GL11.GL_VERTEX_ARRAY);
		gl.glDisable(GL11.GL_TEXTURE_2D);
	}

	private final static float[] BACKGROUND_VERTICES = {
		-10000.0f, 0.0f, -10000.0f,
		0.0f, 0.0f, -10000.0f,
		-10000.0f, 0.0f, 0.0f,
		0.0f, 0.0f, 0.0f,
		0.0f, 0.0f, -10000.0f,
		10000.0f, 0.0f, -10000.0f,
		0.0f, 0.0f, 0.0f,
		10000.0f, 0.0f, 0.0f,
		-10000.0f, 0.0f, 0.0f,
		0.0f, 0.0f, 0.0f,
		-10000.0f, 0.0f, 10000.0f,
		0.0f, 0.0f, 10000.0f,
		0.0f, 0.0f, 0.0f,
		10000.0f, 0.0f, 0.0f,
		0.0f, 0.0f, 10000.0f,
		10000.0f, 0.0f, 10000.0f,
	};

	private final static float[] BACKGROUND_TEX_COORDS = {
		0.0f, 0.0f,
		2.0f, 0.0f,
		0.0f, 2.0f,
		2.0f, 2.0f,
		0.0f, 0.0f,
		2.0f, 0.0f,
		0.0f, 2.0f,
		2.0f, 2.0f,
		0.0f, 0.0f,
		2.0f, 0.0f,
		0.0f, 2.0f,
		2.0f, 2.0f,
		0.0f, 0.0f,
		2.0f, 0.0f,
		0.0f, 2.0f,
		2.0f, 2.0f,
	};

	private static FloatPoints vertices = new FloatPoints(BACKGROUND_VERTICES);
	private static FloatPoints texCoords = new FloatPoints(BACKGROUND_TEX_COORDS);

	private DancingMissilesScene scene;
}
