/*
 * Copyright (c) 2011-2012 Gony
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE ABOVE LISTED COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

package jp.gonypage.dancingmissiles;

import java.util.ArrayList;

import android.graphics.Point;
import android.view.MotionEvent;

public class Touches {
	public Touches() {
		points = new ArrayList<Point>();
	}

	public void update(MotionEvent event, int viewportX, int viewportY, int viewportWidth, int viewportHeight) {
		int count = event.getPointerCount();
		if (event.getAction() == MotionEvent.ACTION_UP) {
			count = 0;
		}
		int pointNum = points.size();
		if (pointNum < count) {
			for (int i = 0;i < count - pointNum;i++) {
				points.add(new Point());
			}
		}
		if (pointNum > count) {
			for (int i = 0;i < pointNum - count;i++) {
				points.remove(0);
			}
		}
		for (int i = 0;i < count;i++) {
			Point point = points.get(i);
			point.x = (int)((event.getX(i) - viewportX) / viewportWidth * 480.0f);
			point.y = (int)((event.getY(i) - viewportY) / viewportHeight * 640.0f);
			if (point.x < 0) {
				point.x = 0;
			}
			if (point.x >= 480) {
				point.x = 479;
			}
			if (point.y < 0) {
				point.y = 0;
			}
			if (point.y >= 640) {
				point.y = 639;
			}
		}
	}

	public int getCount() {
		return points.size();
	}

	public int getX(int index) {
		return points.get(index).x;
	}

	public int getY(int index) {
		return points.get(index).y;
	}

	private ArrayList<Point> points;
}
